<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'record_eod_csrep');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
						'PARAM_REC_EODREP_REC_POSDEVICE_ID',
					    'PARAM_REC_EODREP_TIME_CLOSED'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_EODREP_REC_POSDEVICE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODREP_REC_POSDEVICE_ID', false);
			$PARAM_REC_EODREP_TIME_CLOSED = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_EODREP_TIME_CLOSED', false);

				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$DATA_SET = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
			    // Update CSREP
                $DATA_SET = PHPCUS_RECORD_EOD_CUSTOM::CUS_CSREP_COMPUTE
				(
    				    $PARAM_REC_EODREP_REC_POSDEVICE_ID,
    				    $PARAM_REC_EODREP_TIME_CLOSED,
						true,
						$PDO_HANDLE
				);
                
				// 
				if
				(
				    empty($DATA_SET) || 
				    empty($DATA_SET[0]) || 
				    isset($DATA_SET[0]['INSERTED_ID']
				) == false)
				{
				    PHPVC_LOG::VAR_COMMENTS('$PARAM_REC_EODREP_REC_POSDEVICE_ID', $PARAM_REC_EODREP_REC_POSDEVICE_ID);
				    PHPVC_LOG::VAR_COMMENTS('$PARAM_REC_EODREP_TIME_CLOSED', $PARAM_REC_EODREP_TIME_CLOSED);
				    throw new Exception('Missing expected result : $DATA_SET[0][INSERTED_ID]');
				}
		
				// Update PAYREP
				$DATA_SET = PHPCUS_RECORD_EOD_CUSTOM::CUS_PAYREP_COMPUTE
				(
				    $DATA_SET[0]['INSERTED_ID'],
				    true,
				    $PDO_HANDLE
				);	
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>